#pragma rtGlobals=1		// Use modern global access method.

// Constants from sql.h

Constant SQL_HANDLE_ENV=1
Constant SQL_HANDLE_DBC=2
Constant SQL_HANDLE_STMT=3
Constant SQL_HANDLE_DESC=4

Constant SQL_SUCCESS=0
Constant SQL_SUCCESS_WITH_INFO=1
Constant SQL_STILL_EXECUTING	=2
Constant SQL_ERROR=-1
Constant SQL_INVALID_HANDLE=-2
Constant SQL_NEED_DATA=99
Constant SQL_NO_DATA=100

Constant SQL_MAX_MESSAGE_LENGTH=512

Constant SQL_NULL_DATA=-1
Constant SQL_DATA_AT_EXEC=-2
Constant SQL_NTS=-3
Constant SQL_NTSL=-3

Constant SQL_UNKNOWN_TYPE=0
Constant SQL_CHAR=1
Constant SQL_NUMERIC=2
Constant SQL_DECIMAL=3
Constant SQL_INTEGER=4
Constant SQL_SMALLINT	=5
Constant SQL_FLOAT=6
Constant SQL_REAL=7
Constant SQL_DOUBLE=8
Constant SQL_DATETIME=9
Constant SQL_VARCHAR=12
Constant SQL_ALL_TYPES=0
Constant SQL_BIGINT=-5
Constant SQL_TYPE_DATE=91
Constant SQL_TYPE_TIME=92
Constant SQL_TYPE_TIMESTAMP=93
Constant SQL_DATE_LEN=10
Constant SQL_TIME_LEN=8	 
Constant SQL_TIMESTAMP_LEN=19	 
Constant SQL_NO_NULLS=0
Constant SQL_NULLABLE=1
Constant SQL_NULLABLE_UNKNOWN=2
Constant SQL_NULL_HENV=0
Constant SQL_NULL_HDBC=0
Constant SQL_NULL_HSTMT=0
Constant SQL_NULL_HDESC=0
Constant SQL_NULL_HANDLE=0
Constant SQL_FALSE=0
Constant SQL_TRUE=1
Constant SQL_DEFAULT=99
Constant SQL_FETCH_NEXT=1
Constant SQL_FETCH_FIRST=2
Constant SQL_FETCH_LAST=3
Constant SQL_FETCH_PRIOR=4
Constant SQL_FETCH_ABSOLUTE=5
Constant SQL_FETCH_RELATIVE=6
Constant SQL_CLOSE=0
Constant SQL_DROP=1
Constant SQL_UNBIND=2
Constant SQL_RESET_PARAMS=3
Constant SQL_ATTR_AUTO_IPD=10001
Constant SQL_ATTR_METADATA_ID=10014
Constant SQL_ARD_TYPE=-99
Constant SQL_DESC_COUNT=1001
Constant SQL_DESC_TYPE=1002
Constant SQL_DESC_LENGTH=1003
Constant SQL_DESC_OCTET_LENGTH_PTR=1004
Constant SQL_DESC_PRECISION=1005
Constant SQL_DESC_SCALE=1006
Constant SQL_DESC_DATETIME_INTERVAL_CODE=1007
Constant SQL_DESC_NULLABLE=1008
Constant SQL_DESC_INDICATOR_PTR=1009
Constant SQL_DESC_DATA_PTR=1010
Constant SQL_DESC_NAME=1011
Constant SQL_DESC_UNNAMED=1012
Constant SQL_DESC_OCTET_LENGTH=1013
Constant SQL_DESC_ALLOC_TYPE=1099
Constant SQL_DESC_ALLOC_AUTO=1
Constant SQL_DESC_ALLOC_USER=2
Constant SQL_CODE_DATE=1
Constant SQL_CODE_TIME=2
Constant SQL_CODE_TIMESTAMP=3
Constant SQL_NAMED=0
Constant SQL_UNNAMED=1
Constant SQL_DIAG_RETURNCODE=1
Constant SQL_DIAG_NUMBER=2
Constant SQL_DIAG_ROW_COUNT=3
Constant SQL_DIAG_SQLSTATE=4
Constant SQL_DIAG_NATIVE=5
Constant SQL_DIAG_MESSAGE_TEXT=6
Constant SQL_DIAG_DYNAMIC_FUNCTION=7
Constant SQL_DIAG_CLASS_ORIGIN=8
Constant SQL_DIAG_SUBCLASS_ORIGIN=9
Constant SQL_DIAG_CONNECTION_NAME=10
Constant SQL_DIAG_SERVER_NAME=11
Constant SQL_DIAG_DYNAMIC_FUNCTION_CODE=12
Constant SQL_DIAG_ALTER_DOMAIN=3
Constant SQL_DIAG_ALTER_TABLE=4
Constant SQL_DIAG_CALL=7
Constant SQL_DIAG_CREATE_ASSERTION=6
Constant SQL_DIAG_CREATE_CHARACTER_SET=8
Constant SQL_DIAG_CREATE_COLLATION=10
Constant SQL_DIAG_CREATE_DOMAIN=23
Constant SQL_DIAG_CREATE_INDEX=-1
Constant SQL_DIAG_CREATE_SCHEMA=64
Constant SQL_DIAG_CREATE_TABLE=77
Constant SQL_DIAG_CREATE_TRANSLATION=79
Constant SQL_DIAG_CREATE_VIEW=84
Constant SQL_DIAG_DELETE_WHERE=19
Constant SQL_DIAG_DROP_ASSERTION=24
Constant SQL_DIAG_DROP_CHARACTER_SET=25
Constant SQL_DIAG_DROP_COLLATION=26
Constant SQL_DIAG_DROP_DOMAIN=27
Constant SQL_DIAG_DROP_INDEX=-2
Constant SQL_DIAG_DROP_SCHEMA=31
Constant SQL_DIAG_DROP_TABLE=32
Constant SQL_DIAG_DROP_TRANSLATION=33
Constant SQL_DIAG_DROP_VIEW=36
Constant SQL_DIAG_DYNAMIC_DELETE_CURSOR=38
Constant SQL_DIAG_DYNAMIC_UPDATE_CURSOR=81
Constant SQL_DIAG_GRANT=48
Constant SQL_DIAG_INSERT=50
Constant SQL_DIAG_REVOKE=59
Constant SQL_DIAG_SELECT_CURSOR=85
Constant SQL_DIAG_UNKNOWN_STATEMENT=0
Constant SQL_DIAG_UPDATE_WHERE=82
Constant SQL_ATTR_OUTPUT_NTS=10001
Constant SQL_API_SQLALLOCCONNECT=1
Constant SQL_API_SQLALLOCENV=2
Constant SQL_API_SQLALLOCHANDLE=1001
Constant SQL_API_SQLALLOCSTMT=3
Constant SQL_API_SQLBINDCOL=4
Constant SQL_API_SQLBINDPARAM=1002
Constant SQL_API_SQLCANCEL=5
Constant SQL_API_SQLCLOSECURSOR=1003
Constant SQL_API_SQLCOLATTRIBUTE=6
Constant SQL_API_SQLCOLUMNS=40
Constant SQL_API_SQLCONNECT=7
Constant SQL_API_SQLCOPYDESC=1004
Constant SQL_API_SQLDATASOURCES=57
Constant SQL_API_SQLDESCRIBECOL=8
Constant SQL_API_SQLDISCONNECT=9
Constant SQL_API_SQLENDTRAN=1005
Constant SQL_API_SQLERROR=10
Constant SQL_API_SQLEXECDIRECT=11
Constant SQL_API_SQLEXECUTE=12
Constant SQL_API_SQLFETCH=13
Constant SQL_API_SQLFETCHSCROLL=1021
Constant SQL_API_SQLFREECONNECT=14
Constant SQL_API_SQLFREEENV=15
Constant SQL_API_SQLFREEHANDLE=1006
Constant SQL_API_SQLFREESTMT=16
Constant SQL_API_SQLGETCONNECTATTR=1007
Constant SQL_API_SQLGETCONNECTOPTION=42
Constant SQL_API_SQLGETCURSORNAME=17
Constant SQL_API_SQLGETDATA=43
Constant SQL_API_SQLGETDESCFIELD=1008
Constant SQL_API_SQLGETDESCREC=1009
Constant SQL_API_SQLGETDIAGFIELD=1010
Constant SQL_API_SQLGETDIAGREC=1011
Constant SQL_API_SQLGETENVATTR=1012
Constant SQL_API_SQLGETFUNCTIONS=44
Constant SQL_API_SQLGETINFO=45
Constant SQL_API_SQLGETSTMTATTR=1014
Constant SQL_API_SQLGETSTMTOPTION=46
Constant SQL_API_SQLGETTYPEINFO=47
Constant SQL_API_SQLNUMRESULTCOLS=18
Constant SQL_API_SQLPARAMDATA=48
Constant SQL_API_SQLPREPARE=19
Constant SQL_API_SQLPUTDATA=49
Constant SQL_API_SQLROWCOUNT=20
Constant SQL_API_SQLSETCONNECTATTR=1016
Constant SQL_API_SQLSETCONNECTOPTION=50
Constant SQL_API_SQLSETCURSORNAME=21
Constant SQL_API_SQLSETDESCFIELD=1017
Constant SQL_API_SQLSETDESCREC=1018
Constant SQL_API_SQLSETENVATTR=1019
Constant SQL_API_SQLSETPARAM=22
Constant SQL_API_SQLSETSTMTATTR=1020
Constant SQL_API_SQLSETSTMTOPTION=51
Constant SQL_API_SQLSPECIALCOLUMNS=52
Constant SQL_API_SQLSTATISTICS=53
Constant SQL_API_SQLTABLES=54
Constant SQL_API_SQLTRANSACT=23
Constant SQL_MAX_DRIVER_CONNECTIONS=0
Constant SQL_MAXIMUM_DRIVER_CONNECTIONS=0
Constant SQL_MAX_CONCURRENT_ACTIVITIES=1			// was too long SQL_MAXIMUM_CONCURRENT_ACTIVITIES
Constant SQL_DATA_SOURCE_NAME=2
Constant SQL_FETCH_DIRECTION=8
Constant SQL_SERVER_NAME=13
Constant SQL_SEARCH_PATTERN_ESCAPE=14
Constant SQL_DBMS_NAME=17
Constant SQL_DBMS_VER=18
Constant SQL_ACCESSIBLE_TABLES=19
Constant SQL_ACCESSIBLE_PROCEDURES=20
Constant SQL_CURSOR_COMMIT_BEHAVIOR=23
Constant SQL_DATA_SOURCE_READ_ONLY=25
Constant SQL_DEFAULT_TXN_ISOLATION=26
Constant SQL_IDENTIFIER_CASE=28
Constant SQL_IDENTIFIER_QUOTE_CHAR=29
Constant SQL_MAX_COLUMN_NAME_LEN=30
Constant SQL_MAXIMUM_COLUMN_NAME_LENGTH=30
Constant SQL_MAX_CURSOR_NAME_LEN=31
Constant SQL_MAXIMUM_CURSOR_NAME_LENGTH=31
Constant SQL_MAX_SCHEMA_NAME_LEN=32
Constant SQL_MAXIMUM_SCHEMA_NAME_LENGTH=32
Constant SQL_MAX_CATALOG_NAME_LEN=34
Constant SQL_MAXIMUM_CATALOG_NAME_LENGTH=34
Constant SQL_MAX_TABLE_NAME_LEN=35
Constant SQL_SCROLL_CONCURRENCY=43
Constant SQL_TXN_CAPABLE=46
Constant SQL_TRANSACTION_CAPABLE=46
Constant SQL_USER_NAME=47
Constant SQL_TXN_ISOLATION_OPTION=72
Constant SQL_TRANS_ISOLATION_OPTION=72		// was too long SQL_TRANSACTION_ISOLATION_OPTION
Constant SQL_INTEGRITY=73
Constant SQL_GETDATA_EXTENSIONS=81
Constant SQL_NULL_COLLATION=85
Constant SQL_ALTER_TABLE=86
Constant SQL_ORDER_BY_COLUMNS_IN_SELECT=90
Constant SQL_SPECIAL_CHARACTERS=94
Constant SQL_MAX_COLUMNS_IN_GROUP_BY=97
Constant SQL_MAXIMUM_COLUMNS_IN_GROUP_BY=97
Constant SQL_MAX_COLUMNS_IN_INDEX=98
Constant SQL_MAXIMUM_COLUMNS_IN_INDEX=98
Constant SQL_MAX_COLUMNS_IN_ORDER_BY=99
Constant SQL_MAXIMUM_COLUMNS_IN_ORDER_BY=99
Constant SQL_MAX_COLUMNS_IN_SELECT=100
Constant SQL_MAXIMUM_COLUMNS_IN_SELECT=100
Constant SQL_MAX_COLUMNS_IN_TABLE=101
Constant SQL_MAX_INDEX_SIZE=102
Constant SQL_MAXIMUM_INDEX_SIZE=102
Constant SQL_MAX_ROW_SIZE=104
Constant SQL_MAXIMUM_ROW_SIZE=104
Constant SQL_MAX_STATEMENT_LEN=105
Constant SQL_MAXIMUM_STATEMENT_LENGTH=105
Constant SQL_MAX_TABLES_IN_SELECT=106
Constant SQL_MAXIMUM_TABLES_IN_SELECT=106
Constant SQL_MAX_USER_NAME_LEN=107
Constant SQL_MAXIMUM_USER_NAME_LENGTH=107
Constant SQL_OJ_CAPABILITIES=115
Constant SQL_OUTER_JOIN_CAPABILITIES=115
Constant SQL_XOPEN_CLI_YEAR=10000
Constant SQL_CURSOR_SENSITIVITY=10001
Constant SQL_DESCRIBE_PARAMETER=10002
Constant SQL_CATALOG_NAME=10003
Constant SQL_COLLATION_SEQ=10004
Constant SQL_MAX_IDENTIFIER_LEN=10005
Constant SQL_MAXIMUM_IDENTIFIER_LENGTH=10005
Constant SQL_AT_ADD_COLUMN=0x00000001
Constant SQL_AT_DROP_COLUMN=0x00000002
Constant SQL_AT_ADD_CONSTRAINT=0x00000008
Constant SQL_AT_COLUMN_SINGLE=0x00000020
Constant SQL_AT_ADD_COLUMN_DEFAULT=0x00000040
Constant SQL_AT_ADD_COLUMN_COLLATION=0x00000080
Constant SQL_AT_SET_COLUMN_DEFAULT=0x00000100
Constant SQL_AT_DROP_COLUMN_DEFAULT=0x00000200
Constant SQL_AT_DROP_COLUMN_CASCADE=0x00000400
Constant SQL_AT_DROP_COLUMN_RESTRICT=0x00000800
Constant SQL_AT_ADD_TABLE_CONSTRAINT=0x00001000
Constant SQL_AT_DROP_TAB_CONSTR_CASCADE=0x00002000				// was too long SQL_AT_DROP_TABLE_CONSTRAINT_CASCADE
Constant SQL_AT_DROP_TAB_CONSTR_RESTRICT=0x00004000				// was too long SQL_AT_DROP_TABLE_CONSTRAINT_RESTRICT
Constant SQL_AT_CONSTR_NAME_DEFINITION=0x00008000				// was too long SQL_AT_CONSTRAINT_NAME_DEFINITION
Constant SQL_AT_CONSTR_INIT_DEFERRED=0x00010000					// was too long SQL_AT_CONSTRAINT_INITIALLY_DEFERRED
Constant SQL_AT_CONSTR_INIT_IMMEDIATE=0x00020000					// was too long SQL_AT_CONSTRAINT_INITIALLY_IMMEDIATE
Constant SQL_AT_CONSTRAINT_DEFERRABLE=0x00040000
Constant SQL_AT_CONSTR_NON_DEFERRABLE=0x00080000				// was too long SQL_AT_CONSTRAINT_NON_DEFERRABLE
Constant SQL_AM_NONE=0
Constant SQL_AM_CONNECTION=1
Constant SQL_AM_STATEMENT=2
Constant SQL_CB_DELETE=0
Constant SQL_CB_CLOSE=1
Constant SQL_CB_PRESERVE=2
Constant SQL_FD_FETCH_NEXT=0x00000001
Constant SQL_FD_FETCH_FIRST=0x00000002
Constant SQL_FD_FETCH_LAST=0x00000004
Constant SQL_FD_FETCH_PRIOR=0x00000008
Constant SQL_FD_FETCH_ABSOLUTE=0x00000010
Constant SQL_FD_FETCH_RELATIVE=0x00000020
Constant SQL_GD_ANY_COLUMN=0x00000001
Constant SQL_GD_ANY_ORDER=0x00000002
Constant SQL_IC_UPPER=1
Constant SQL_IC_LOWER=2
Constant SQL_IC_SENSITIVE=3
Constant SQL_IC_MIXED=4
Constant SQL_NC_HIGH=0
Constant SQL_NC_LOW=1
Constant SQL_OJ_LEFT=0x00000001
Constant SQL_OJ_RIGHT=0x00000002
Constant SQL_OJ_FULL=0x00000004
Constant SQL_OJ_NESTED=0x00000008
Constant SQL_OJ_NOT_ORDERED=0x00000010
Constant SQL_OJ_INNER=0x00000020
Constant SQL_OJ_ALL_COMPARISON_OPS=0x00000040
Constant SQL_SCCO_READ_ONLY=0x00000001
Constant SQL_SCCO_LOCK=0x00000002
Constant SQL_SCCO_OPT_ROWVER=0x00000004
Constant SQL_SCCO_OPT_VALUES=0x00000008
Constant SQL_TC_NONE=0
Constant SQL_TC_DML=1
Constant SQL_TC_ALL=2
Constant SQL_TC_DDL_COMMIT=3
Constant SQL_TC_DDL_IGNORE=4
Constant SQL_TXN_READ_UNCOMMITTED=0x00000001
Constant SQL_TRANS_READ_UNCOMMITTED=0x00000001					// was too long SQL_TRANSACTION_READ_UNCOMMITTED
Constant SQL_TXN_READ_COMMITTED=0x00000002
Constant SQL_TRANSACTION_READ_COMMITTED=0x00000002
Constant SQL_TXN_REPEATABLE_READ=0x00000004
Constant SQL_TRANSACTION_REPEATABLE_READ=0x00000004
Constant SQL_TXN_SERIALIZABLE=0x00000008
Constant SQL_TRANSACTION_SERIALIZABLE=0x00000008
Constant SQL_ATTR_APP_ROW_DESC=10010
Constant SQL_ATTR_APP_PARAM_DESC=10011
Constant SQL_ATTR_IMP_ROW_DESC=10012
Constant SQL_ATTR_IMP_PARAM_DESC=10013
Constant SQL_ATTR_CURSOR_SCROLLABLE=-1
Constant SQL_ATTR_CURSOR_SENSITIVITY=-2
Constant SQL_NONSCROLLABLE=0
Constant SQL_SCROLLABLE=1
Constant SQL_UNSPECIFIED=0
Constant SQL_INSENSITIVE=1
Constant SQL_SENSITIVE=2
Constant SQL_PRED_NONE=0
Constant SQL_PRED_CHAR=1
Constant SQL_PRED_BASIC=2
Constant SQL_SCOPE_CURROW=0
Constant SQL_SCOPE_TRANSACTION=1
Constant SQL_SCOPE_SESSION=2
Constant SQL_PC_UNKNOWN=0
Constant SQL_PC_NON_PSEUDO=1
Constant SQL_PC_PSEUDO=2
Constant SQL_ROW_IDENTIFIER=1
Constant SQL_INDEX_UNIQUE=0
Constant SQL_INDEX_ALL=1
Constant SQL_INDEX_CLUSTERED=1
Constant SQL_INDEX_HASHED=2
Constant SQL_INDEX_OTHER=3
Constant SQL_COMMIT=0
Constant SQL_ROLLBACK=1

// Constants from sqlext.h

Constant  SQL_POSITION=0
Constant  SQL_REFRESH=1
Constant  SQL_UPDATE=2
Constant  SQL_DELETE=3

Constant SQL_LOCK_NO_CHANGE=0
Constant SQL_LOCK_EXCLUSIVE=1
Constant SQL_LOCK_UNLOCK=2
Constant SQL_SETPOS_MAX_LOCK_VALUE=2

Constant SQL_COLUMN_COUNT=0
Constant SQL_COLUMN_NAME=1
Constant SQL_COLUMN_TYPE=2
Constant SQL_COLUMN_LENGTH=3
Constant SQL_COLUMN_PRECISION=4
Constant SQL_COLUMN_SCALE=5
Constant SQL_COLUMN_DISPLAY_SIZE=6
Constant SQL_COLUMN_NULLABLE=7
Constant SQL_COLUMN_UNSIGNED=8
Constant SQL_COLUMN_MONEY=9
Constant SQL_COLUMN_UPDATABLE=10
Constant SQL_COLUMN_AUTO_INCREMENT=11
Constant SQL_COLUMN_CASE_SENSITIVE=12
Constant SQL_COLUMN_SEARCHABLE=13
Constant SQL_COLUMN_TYPE_NAME=14
Constant SQL_COLUMN_TABLE_NAME=15
Constant SQL_COLUMN_OWNER_NAME=16
Constant SQL_COLUMN_QUALIFIER_NAME=17
Constant SQL_COLUMN_LABEL=18
Constant SQL_COLATT_OPT_MAX	=18

Constant SQL_ATTR_READONLY=0
Constant SQL_ATTR_WRITE=1
Constant SQL_ATTR_READWRITE_UNKNOWN	=2

Constant SQL_UNSEARCHABLE=0
Constant SQL_LIKE_ONLY=1
Constant SQL_ALL_EXCEPT_LIKE=2
Constant SQL_SEARCHABLE=3
Constant SQL_PRED_SEARCHABLE=3

Constant SQL_FETCH_FIRST_USER=31
Constant SQL_FETCH_FIRST_SYSTEM=32

Constant SQL_DRIVER_NOPROMPT=0
Constant SQL_DRIVER_COMPLETE=1
Constant SQL_DRIVER_PROMPT=2
Constant SQL_DRIVER_COMPLETE_REQUIRED=3

Constant SQL_ACCESS_MODE=101
Constant SQL_AUTOCOMMIT=102
Constant SQL_LOGIN_TIMEOUT=103
Constant SQL_OPT_TRACE=104
Constant SQL_OPT_TRACEFILE=105
Constant SQL_TRANSLATE_DLL=106
Constant SQL_TRANSLATE_OPTION=107
Constant SQL_TXN_ISOLATION=108
Constant SQL_CURRENT_QUALIFIER=109
Constant SQL_ODBC_CURSORS=110
Constant SQL_QUIET_MODE=111
Constant SQL_PACKET_SIZE=112

// Connection attributes
Constant SQL_ATTR_ACCESS_MODE=101
Constant SQL_ATTR_AUTOCOMMIT=102
Constant SQL_ATTR_CONNECTION_TIMEOUT=113
Constant SQL_ATTR_CURRENT_CATALOG=109
Constant SQL_ATTR_DISCONNECT_BEHAVIOR=114
Constant SQL_ATTR_ENLIST_IN_DTC=1207
Constant SQL_ATTR_ENLIST_IN_XA=1208
Constant SQL_ATTR_LOGIN_TIMEOUT=103
Constant SQL_ATTR_ODBC_CURSORS	=110
Constant SQL_ATTR_PACKET_SIZE=112
Constant SQL_ATTR_QUIET_MODE=111
Constant SQL_ATTR_TRACE=104
Constant SQL_ATTR_TRACEFILE=105
Constant SQL_ATTR_TRANSLATE_LIB=106
Constant SQL_ATTR_TRANSLATE_OPTION=107
Constant SQL_ATTR_TXN_ISOLATION	=108
Constant SQL_ATTR_ODBC_VERSION=200
Constant SQL_ATTR_CONNECTION_POOLING=201
Constant SQL_ATTR_CP_MATCH=202

// Statement attributes
Constant SQL_QUERY_TIMEOUT=0
Constant SQL_MAX_ROWS=1
Constant SQL_NOSCAN=2
Constant SQL_MAX_LENGTH=3
Constant SQL_ASYNC_ENABLE=4	
Constant SQL_BIND_TYPE=5
Constant SQL_CURSOR_TYPE=6
Constant SQL_CONCURRENCY	=7
Constant SQL_KEYSET_SIZE=8
Constant SQL_ROWSET_SIZE=9
Constant SQL_SIMULATE_CURSOR=10
Constant SQL_RETRIEVE_DATA=11
Constant SQL_USE_BOOKMARKS=12
Constant SQL_GET_BOOKMARK=13
Constant SQL_ROW_NUMBER=14
Constant SQL_ATTR_ASYNC_ENABLE=4
Constant SQL_ATTR_CONCURRENCY=7
Constant SQL_ATTR_CURSOR_TYPE=6
Constant	SQL_ATTR_ENABLE_AUTO_IPD=15
Constant SQL_ATTR_FETCH_BOOKMARK_PTR=16
Constant SQL_ATTR_KEYSET_SIZE	=8
Constant SQL_ATTR_MAX_LENGTH	=3
Constant SQL_ATTR_MAX_ROWS=1
Constant SQL_ATTR_NOSCAN=2
Constant SQL_ATTR_PARAM_BIND_OFFSET_PTR=17
Constant	SQL_ATTR_PARAM_BIND_TYPE=18
Constant SQL_ATTR_PARAM_OPERATION_PTR=19
Constant SQL_ATTR_PARAM_STATUS_PTR=20
Constant	SQL_ATTR_PARAMS_PROCESSED_PTR=21
Constant	SQL_ATTR_PARAMSET_SIZE=22
Constant SQL_ATTR_QUERY_TIMEOUT=0
Constant SQL_ATTR_RETRIEVE_DATA=11
Constant SQL_ATTR_ROW_BIND_OFFSET_PTR=23
Constant	SQL_ATTR_ROW_BIND_TYPE=5
Constant SQL_ATTR_ROW_NUMBER=14
Constant SQL_ATTR_ROW_OPERATION_PTR=24
Constant	SQL_ATTR_ROW_STATUS_PTR=25
Constant	SQL_ATTR_ROWS_FETCHED_PTR=26
Constant SQL_ATTR_ROW_ARRAY_SIZE=27	
Constant SQL_ATTR_SIMULATE_CURSOR=10
Constant SQL_ATTR_USE_BOOKMARKS=12	
Constant SQL_STMT_OPT_MAX=14
Constant SQL_STMT_OPT_MIN=0
Constant SQL_PARAM_BIND_BY_COLUMN=0
Constant SQL_PARAM_BIND_TYPE_DEFAULT=0
Constant SQL_UB_DEFAULT=0
Constant SQL_UB_FIXED=1
Constant SQL_UB_VARIABLE=2

// SQL_BIND_TYPE options
Constant SQL_BIND_BY_COLUMN=0
Constant SQL_BIND_TYPE_DEFAULT=0

// C Data Types
Constant SQL_C_CHAR=1
Constant SQL_C_STINYINT=-6
Constant SQL_C_UTINYINT=-28
Constant SQL_C_SSHORT=-15		// (5-20)
Constant SQL_C_USHORT=-17 		// (5-22)
Constant SQL_C_SLONG=-16		// (4-20)
Constant SQL_C_ULONG=-18		//(4-22)
Constant SQL_C_FLOAT=7
Constant SQL_C_DOUBLE=8

// Descriptors
Constant SQL_DESC_ARRAY_SIZE=20
Constant SQL_DESC_ARRAY_STATUS_PTR=21
Constant SQL_DESC_AUTO_UNIQUE_VALUE=11
Constant SQL_DESC_BASE_COLUMN_NAME=22
Constant SQL_DESC_BASE_TABLE_NAME	=23
Constant SQL_DESC_BIND_OFFSET_PTR=24
Constant SQL_DESC_BIND_TYPE	=25
Constant SQL_DESC_CASE_SENSITIVE=12
Constant SQL_DESC_CATALOG_NAME	=17
Constant SQL_DESC_CONCISE_TYPE=2
Constant SQL_DESC_DATETIME_INTER_PREC=26	// was SQL_DESC_DATETIME_INTERVAL_PRECISION
Constant SQL_DESC_DISPLAY_SIZE=6
Constant SQL_DESC_FIXED_PREC_SCALE=9
Constant SQL_DESC_LABEL=18
Constant SQL_DESC_LITERAL_PREFIX=27
Constant SQL_DESC_LITERAL_SUFFIX=28
Constant SQL_DESC_LOCAL_TYPE_NAME	=29
Constant SQL_DESC_MAXIMUM_SCALE=30
Constant SQL_DESC_MINIMUM_SCALE=31
Constant SQL_DESC_NUM_PREC_RADIX=32
Constant SQL_DESC_PARAMETER_TYPE=33
Constant SQL_DESC_ROWS_PROCESSED_PTR=34
Constant SQL_DESC_ROWVER=35
Constant SQL_DESC_SCHEMA_NAME	=16
Constant SQL_DESC_SEARCHABLE=13
Constant SQL_DESC_TYPE_NAME=14
Constant SQL_DESC_TABLE_NAME=15
Constant SQL_DESC_UNSIGNED=8
Constant SQL_DESC_UPDATABLE	=10

// Selected extended SQLGetInfo values
Constant SQL_DYNAMIC_CURSOR_ATTRS1 = 144			// SQL_DYNAMIC_CURSOR_ATTRIBUTES1
Constant SQL_DYNAMIC_CURSOR_ATTRS2 = 145			// SQL_DYNAMIC_CURSOR_ATTRIBUTES2
Constant SQL_FORWARD_ONLY_CURSOR_ATTRS1 = 146	// SQL_FORWARD_ONLY_CURSOR_ATTRIBUTES1		
Constant SQL_FORWARD_ONLY_CURSOR_ATTRS2 = 147	// SQL_FORWARD_ONLY_CURSOR_ATTRIBUTES2
Constant SQL_KEYSET_CURSOR_ATTRS1 = 150				// SQL_KEYSET_CURSOR_ATTRIBUTES1
Constant SQL_KEYSET_CURSOR_ATTRS2 = 151				// SQL_KEYSET_CURSOR_ATTRIBUTES2
Constant SQL_STATIC_CURSOR_ATTRS1 = 167				// SQL_STATIC_CURSOR_ATTRIBUTES1
Constant SQL_STATIC_CURSOR_ATTRS2 = 168				// SQL_STATIC_CURSOR_ATTRIBUTES2

Constant SQL_QUICK=0
Constant SQL_ENSURE=1

Constant SQL_AF_AVG=0x00000001
Constant SQL_AF_COUNT=0x00000002
Constant SQL_AF_MAX=0x00000004
Constant SQL_AF_MIN=0x00000008
Constant SQL_AF_SUM=0x00000010
Constant SQL_AF_DISTINCT=0x00000020
Constant SQL_AF_ALL=0x00000040

// For SQLBindParameter and SQLProcedureColumns
Constant SQL_PARAM_TYPE_UNKNOWN = 0
Constant SQL_PARAM_INPUT = 1
Constant SQL_PARAM_INPUT_OUTPUT = 2
Constant SQL_RESULT_COL = 3
Constant SQL_PARAM_OUTPUT = 4
Constant SQL_RETURN_VALUE = 5
